function Classification
% Builds DFs.

% Load the PreClassification results.
PC = load('PreClassification.mat');
P = PC.P;
X_TRAIN = PC.X_TRAIN;
X_TRAIN_IDs = PC.X_TRAIN_IDs;
PORTFOLIO = PC.PORTFOLIO;

% nosolver (backup solver is chosen) is placed in 2nd position.
NSI = [10 8 3 7 4 5 12 13 9 1 6 11 2];
% Returns the ID of the solver which resolves more instances.
function best = bestNSI(i, j)
    if NSI(i) < NSI(j)
        best = i;
    else
        best = j;
    end
end

% Train the cost-sensitive decision forests DF{i}{j}
NUM_SOLV = 12;
DFs = cell(NUM_SOLV - 2, 1);
NUM_FEAT = 143;
NVAR = ceil(log2(NUM_FEAT) + 1);
for n_solver = 2:NUM_SOLV - 1
    sprintf('No. solvers: %d', n_solver)
    pf = PORTFOLIO{n_solver}';
    for rep = 1:5
        sprintf('Repetition: %d', rep)
        for fold = 1:5
            sprintf('Fold: %d', fold)
            x = X_TRAIN{rep}{fold};
            DF = cell(n_solver * (n_solver + 1) / 2, 1);
            for i = pf
                for j = pf
                    if i < j
                        sprintf('i-th solver ID: %d', i)
                        sprintf('j-th solver ID: %d', j)
                        idx = X_TRAIN_IDs{rep}{fold};
                        y = zeros(size(idx));
                        Pi = P(idx, i);
                        Pj = P(idx, j);
                        y(Pi < Pj) = i;
                        y(Pj < Pi) = j;
                        y(Pi == Pj) = bestNSI(i, j);
                        w = abs(Pi - Pj);
                        if length(x) == length(y) + 1
                            x = x(1:length(y), :);
                        end
                        sprintf('Bagging...')
                        DF{i}{j} = TreeBagger(99, x, y, 'Method', 'classification', 'W', w, 'NVarToSample', NVAR);
                    end
                end
            end
            DFs{n_solver}{rep}{fold} = DF;
            save(strcat(num2str(n_solver), '_solvers/class_', num2str(n_solver), 'solvers_rep', num2str(rep), '_fold', num2str(fold)), 'DF');
        end
    end
end

% Save the results.
save('Classification', 'DFs');

end