function Predictions
% Build predictions.

PC = load('PreClassification.mat');
PORTFOLIO = PC.PORTFOLIO;

PP = load('PrePredictions.mat');
X_TEST = PP.X_TEST;
SOLVERs = PP.SOLVERs;

% nosolver (backup solver is chosen) is placed in 2nd position.
NSI = [10 8 3 7 4 5 12 13 9 1 6 11 2];
% Returns the ID of the solver which resolves more instances.
function best = bestNSI(i, j)
    if NSI(i) < NSI(j)
        best = i;
    else
        best = j;
    end
end

% Build predictions.
NUM_SOLV = 12
for n_solver = 2:NUM_SOLV - 1
    sprintf('No. solvers: %d', n_solver)
    for rep = 1:5
        sprintf('Repetition: %d', rep)
        for fold = 1:5
            sprintf('Fold: %d', fold)
            CL = load(strcat(num2str(n_solver), '_solvers/class_', num2str(n_solver), 'solvers_rep', num2str(rep), '_fold', num2str(fold)));
            DF = CL.DF;
            x = X_TEST{rep}{fold};
            n = length(x);
            if sum(x(n, :)) == 0
                n = n - 1;
                x = x(1:n, :);
            end
            pf = PORTFOLIO{n_solver}';
            m = n_solver + 1;
            V = zeros(n, m * (m - 1) / 2);
            k = 0;
            for i = pf
                for j = pf
                    if i < j
                        sprintf('i-th solver ID: %d', i)
                        sprintf('j-th solver ID: %d', j)
                        k = k + 1;
                        y_pred = predict(DF{i}{j}, x);
                        V(:, k) = str2double(y_pred);
                    end
                end
            end
            
            Y = zeros(n, 1);
            S = cell(n, 1);
            for k = 1:n              
                pf = PORTFOLIO{n_solver}';
                votes = zeros(1, NUM_SOLVER + 1);         
                for h = pf
                    votes(h) = sum(V(k, :) == h);
                end
                tie = find(votes == max(votes));
                Y(k) = tie(1);
                for h = 2:length(tie)
                    % FIXME: This is not the paper's way.
                    Y(k) = bestNSI(Y(k), tie(h));    
                end
                S{k} = SOLVERs{Y(k)};
            end
            fid = fopen(strcat(num2str(n_solver), '_solvers/test_', num2str(n_solver), 'solvers_rep', num2str(rep), '_fold', num2str(fold)), 'w');
            fprintf(fid, '%s\n', S{:});
        end
    end
end

end
