'''
Computes the features needed by SATzilla approach.
'''

import sys
import csv
import pickle

FEAT_FILE = '/public/xcsp_instances/new/features/csp/features.csv'
NUM_FEAT = 144
IN_PATH = '/public/xcsp_instances/new/dataset/csp/train_test/'
OUT_PATH = '/public/xcsp_instances/new/scripts/classifiers/csp/SATzilla/features/'

def main(args):
  features = {}
  feat_reader = csv.reader(open(FEAT_FILE, 'rb'),  delimiter = '|')
  for row in feat_reader:
    features[row[0]] = row[1: NUM_FEAT]

  for rep in range(1, 6):
    for fold in range(1, 6):
      suffix = 'rep' + str(rep) + '_fold' + str(fold)
      train = pickle.load(open(IN_PATH + 'train_' + suffix))
      feat_writer = csv.writer(
        open(OUT_PATH + 'train_'+ suffix + '.features', 'wb'),  delimiter = ' '
      )
      for inst in train:
        row = [inst]
        row.extend(features[inst])
        feat_writer.writerow(row)

      test = pickle.load(open(IN_PATH + 'test_' + suffix))
      feat_writer = csv.writer(
        open(OUT_PATH + 'test_'+ suffix + '.features', 'wb'),  delimiter = ' '
      )
      for inst in test:
        row = [inst]
        row.extend(features[inst])
        feat_writer.writerow(row)

if __name__ == '__main__':
  main(sys.argv[1:])

